<?php

namespace App\Controller;

use App\Forms\UploadFileForm;
use App\Objects\UploadedFileData;
use App\Service\FileSystemService;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

class HomeController extends AbstractController
{
    #[Route(path: '/', name: 'app_home', methods: [Request::METHOD_GET, Request::METHOD_POST])]
    public function __invoke(
        FileSystemService $fileSystemService,
        Request $request,
    ): Response
    {
        $fileData = new UploadedFileData();
        $form  = $this->createForm(UploadFileForm::class, $fileData)->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            dd($form->getData(), $form->getExtraData());
            $fileSystemService->uploadFile($fileData->file);

            return $this->redirectToRoute('app_home');
        }

        return $this->render('home.html.twig', [
            'content' => $fileSystemService->getDirs(),
            'fileForm' => $form,
        ]);
    }
}